<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>2.6 Assignment Operators</title>
<link href="sx2e.html" rev=precedes>
<link href="sx2g.html" rel=precedes>
<link href="sx2.html" rev=subdocument>
</head>
<body>
<H2>2.6 Assignment Operators</H2>

<p>[This section corresponds to K&amp;R Sec. 2.10]
</p><p>The assignment operator <TT>=</TT> assigns a value to a variable.
For example,
<pre>
	x = 1
</pre>
sets <TT>x</TT> to 1,
and
<pre>
	a = b
</pre>
sets <TT>a</TT> to whatever <TT>b</TT>'s value is.
The expression
<pre>
	i = i + 1
</pre>
is, as we've mentioned elsewhere, the standard programming 
idiom for increasing a variable's value by 1:
this expression takes <TT>i</TT>'s old value, adds 1 to it, 
and stores it back into <TT>i</TT>.
(C provides several ``shortcut'' operators for 
modifying variables in this and similar ways, which we'll meet 
later.)
</p><p>We've called the <TT>=</TT> sign the ``assignment operator''
and referred to ``assignment expressions''
because, in fact, <TT>=</TT> <em>is</em> an operator just like 
<TT>+</TT> or <TT>-</TT>.
C does not have ``assignment statements'';
instead,
an assignment like <TT>a = b</TT> is an expression
and can be used wherever any expression can appear.
Since it's an expression,
the assignment <TT>a = b</TT> has a value,
namely, the same value that's assigned to <TT>a</TT>.
This value can then be used in a larger expression;
for example,
we might write
<pre>
	c = a = b
</pre>
which is equivalent to
<pre>
	c = (a = b)
</pre>
and assigns <TT>b</TT>'s value to both <TT>a</TT> and <TT>c</TT>.
(The assignment operator, therefore, groups from right to left.)
Later we'll see other circumstances
in which it can be useful to use the value of an assignment expression.
</p><p>It's usually a matter of style whether you initialize a 
variable with an initializer in its declaration or with an 
assignment expression near where you first use it.
That is,
there's no particular difference between
<pre>
	int a = 10;
</pre>
and
<pre>
	int a;

	/* later... */

	a = 10;
</pre>
</p><hr>
<p>
Read sequentially:
<a href="sx2e.html" rev=precedes>prev</a>
<a href="sx2g.html" rel=precedes>next</a>
<a href="sx2.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
